# -*- coding: euc-kr -*-
# This module is part of the Lupy project and is Copyright 2003 Amir
# Bakhtiar (amir@divmod.org). This is free software; you can redistribute
# it and/or modify it under the terms of version 2.1 of the GNU Lesser
# General Public License as published by the Free Software Foundation.
"""
 Ͽ Document ߰ϴ  
  Document ޸𸮿 ϰ ȴ.

"""
import sys

from lupy import store
from lupy.index import segmentmerger, segment, documentwriter

class IndexWriter(object):
    """ε Document ߰Ѵ. ׸  ε   ʱⰪ Ѵ."""
    def __init__(self, path, create=False, analyzer=None):
        if path is None:
            if create is True: # ε   ƴϸ, 
                self.directory = store.RAMDirectory() # 丮  ȵǾ  ޸ ̿
            else: 
                self.directory = path # None
        else: # path ý  
            self.directory = store.FSDirectory(path, create)
            
        self.infoStream = None
        self.analyzer = analyzer
        self.maxMergeDocs = sys.maxint # ׸Ʈ ִ 
        # Document ũ  ޸𸮿  Document     ׸Ʈ ϴ 󵵼 Ѵ.
        self.mergeFactor = 20 
        self.segmentInfos = segment.SegmentInfos()
        self.ramDirectory = store.RAMDirectory()
        # self.writeLock = open("write.lock", "wb")
        # locker.lock(self.writeLock, locker.LOCK_EX)
        
        if create is True: # ο ׸Ʈ  .
            self.segmentInfos.write(self.directory)
        else: #  ׸Ʈ Ͽ о´.
            self.segmentInfos.read(self.directory)


    def close(self):
        """ õ Directory ݰ  ׸Ʈ flushѴ."""
        self.flushRamSegments()
        self.ramDirectory.close()
        # self.writeLock.close()
        self.directory.close()


    def docCount(self):
        """ ׸Ʈ   Ѵ"""
        count = 0
        for si in self.segmentInfos:
            count += si.docCount
        return count


    def addDocument(self, doc):
        """ add document writer , ׸Ʈ  Ѵ. """
        dw = documentwriter.DocumentWriter(self.ramDirectory, self.analyzer) #мؾߵ κ ()
        segmentName = self.newSegmentName()
        dw.addDocument(segmentName, doc)
        self.segmentInfos.append(segment.SegmentInfo(segmentName, 1, self.ramDirectory))
        self.maybeMergeSegments()


    def newSegmentName(self):
        """ο ׸Ʈ ߰ν ׸Ʈ  ø.
        Ƹ segmentInfos merge   ׸Ʈ ϴ° ƴѰ ñϴ.
         ׸Ʈ  ϴ κ segmentInfos ؼ ϴ° ƴѰ Ѵ.
        ׷   _( + 1).xxx  ε   ȴ.
        """
        res = '_' + str(self.segmentInfos.counter)
        self.segmentInfos.counter += 1
        return res


    def optimize(self):
        """   ϳ ϴ ޼(⼭ merge ڵ δ.) Compound ϴ ۾ ƴϴ.
         ȭ ϴ ۾ ο  ˻ӵ  ְ  ӵ   ʴ´.
        """
        self.flushRamSegments()
        while ((len(self.segmentInfos) > 1) or (len(self.segmentInfos) == 1 and
                (segmentmerger.SegmentReader.hasDeletions(self.segmentInfos[0]) or
                 self.segmentInfos[0].dir != self.directory))):
            minSegment = (len(self.segmentInfos) - self.mergeFactor)
            if minSegment < 0:
                self.mergeSegments(0)
            else:
                self.mergeSegments(minSegment)


    def addIndexes(self, dirs):
        """Merges all segments from an array of indexes into this index.
        
        This may be used to parallelize batch indexing.  A large document
        collection can be broken into sub-collections.  Each sub-collection can be
        indexed in parallel, on a different thread, process or machine.  The
        complete index can then be created by merging sub-collection indexes
        with this method.
        
        After this completes, the index is optimized."""
        #### UNTESTED ####
        self.optimize()
        for d in dirs:
            sis = segment.SegmentInfos()
            sis.read(d)
            for j in range(len(sis)):
                self.segmentInfos.append(sis[j])
        self.optimize()


    def flushRamSegments(self):
        """
        ޸𸮿 ִ   ׸Ʈ Ѵ. mergeFactor ̴޵   ̴. 
         ׸Ʈ   ڵ鸵 Ѵ. mergeFactor  merge
        mergeFactor ̴  쿡  ׸Ʈ( )  ع.
        """
        sis = self.segmentInfos
        minSegment = len(sis) - 1 #Ȯ ε ϱ 
        docCount = 0

        # 丮  ǰ   Ϸ  Ǵ 
        # ramDirectory Ѱ  ǹϴ ƴ° ʿϴ.
        while minSegment >= 0 and ((sis[minSegment]).dir == self.ramDirectory):
            docCount += sis[minSegment].docCount
            minSegment -= 1

        # docCount  丮 ִ    ȴ. 

        if (minSegment < 0 or (docCount + sis[minSegment].docCount) > self.mergeFactor or
            not (sis[len(sis)-1].dir == self.ramDirectory)):
            minSegment += 1

        if minSegment >= len(sis):
            return
        self.mergeSegments(minSegment)


    def maybeMergeSegments(self):
        """
         ׸Ʈ 
        ӽ÷  Document ׸Ʈȭ Ǿ ޸𸮿 Ǿ ִ.  ޸𸮿  ͵ 
        mergeFactor  ѹ üũ ذ鼭 ϳ ׸Ʈ  Ѵ.
        merge Doc غǸ 
        ⼭  
        targetMergeDocs *= self.mergeFactor 
         ̴µ ̺κ  mergeFactor 20̶ ù°   20   
        ϴµ  ι°   400 ų  ϳ ׸Ʈ  Ѵ.
        ⼭ mergeFactor ޸𸮿 Ǵ Document  ǹ԰ ÿ ׸Ʈ  
        ϴ ұ ϴ°̴. 19  RamDirectory    ǰ 20  
        addʰ ÿ  ϳ ׸Ʈ  ǰ 20  ִ ׸Ʈ 20 
         ÿ ϳ ׸Ʈ  Ǵ ̴.
        ׷ ϳ ο 20 ̻ ׸Ʈ  ʰ ȴ. 
        """
        targetMergeDocs = self.mergeFactor
        while targetMergeDocs <= self.maxMergeDocs:
            # ǥ(mergeFactor^n)  ׸Ʈ  ãƳ.
            minSegment = len(self.segmentInfos)
            mergeDocs = 0
            minSegment -= 1
            while minSegment >= 0:
                si = self.segmentInfos[minSegment]
                if si.docCount >= targetMergeDocs:
                    break
                # ׸Ʈ   ̾ƿ´. 1ϼ ְ ϼ ִ.
                mergeDocs += si.docCount 
                minSegment -= 1
            if mergeDocs >= targetMergeDocs: #ãҴ.
                self.mergeSegments(minSegment + 1)
            else:
                break
            #Ÿ  ٽ ʷƮ Ų.
            targetMergeDocs *= self.mergeFactor 
            

    def mergeSegments(self, minSegment):
        """
        segmentInfos minsegment ̾Ƽ merge Ų  segmentInfos ٽ
        ִ´.  ⼭ minSegment  ˾ƾ Ѵ.
         segmentInfos Ѵ.
        """
        
        mergedName = self.newSegmentName()
        mergedDocCount = 0
        merger = segmentmerger.SegmentMerger(self.directory, mergedName) #SegmentMerger ̿ ׸Ʈ 
        segmentsToDelete = []
        
        for i in range(minSegment, len(self.segmentInfos)):
            si = self.segmentInfos[i]
            reader = segmentmerger.SegmentReader(si)
            merger.add(reader)
            if reader.directory is self.directory or reader.directory is self.ramDirectory: #޸𸮿 ֵ Ͽ ֵ 
                segmentsToDelete.append(reader)
            mergedDocCount += si.docCount
        merger.merge()

        self.segmentInfos = self.segmentInfos[:minSegment]
        self.segmentInfos.append(segment.SegmentInfo(mergedName,
                                                         mergedDocCount,
                                                         self.directory))

        # TODO some locking here
        self.segmentInfos.write(self.directory)     # commit before deleting
        self.deleteSegments(segmentsToDelete)      # delete now-unused segments
        

    def deleteSegments(self, segs):
        """
         ü   ¿ ° Ѵ. ׷ ° ȵɰ
         ť ־   õѴ.
        """
        
        deletable = []
        #  ȵȴٸ deletable Ʈ ߰Ѵ.
        self.deleteFilesList(self.readDeleteableFiles(), deletable) # try to delete deletable
        
        for reader in segs:
            if reader.directory is self.directory: # 丮  ٸ 
                self.deleteFilesList(reader.files(), deletable) # segs ִ segment reader    .
            else:
                self.deleteFilesDir(reader.files(), reader.directory)  # delete, eg, RAM files
            self.writeDeleteableFiles(deletable)                #    deletable Ѵ.
            

    def deleteFilesDir(self, files, dir):
        for file in files:
            dir.deleteFile(file)


    def deleteFilesList(self, files, deletable):
        """files ׸ .  Ѵٸ deletable Է д"""
        for file in files:
            try:
                self.directory.deleteFile(file)
            except OSError:
	        # this occurs on windows where sometimes
		# win reports a file to be in use
		# in reality it is windows that is fiddling
		# with the file and locking it temporarily
                if self.directory.fileExists(file):
		    # schedule the file for later deletion
                    deletable.append(file)


    def readDeleteableFiles(self):
        """deletable  ãƺ."""
        result = []
        if not self.directory.fileExists('deletable'):
            return result
        input = self.directory.openFile('deletable')
        try:
            i = input.readInt()
            while i > 0:
                result.append(input.readString())
                i -= 1
        finally:
            input.close()
        return result


    def writeDeleteableFiles(self, files):
        """׻ deletable.new ϰ  ӽ ΰ renamaѴ."""
        output = self.directory.createFile('deletable.new')
        try:
            output.writeInt(len(files))
            for file in files:
                output.writeString(file)
        finally:
            output.close()
        self.directory.renameFile('deletable.new','deletable')
